#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "sphere.h"
#include "implemented.h"

Sphere::Sphere(FILE* fp,int* index){
  if(fscanf(fp," %d %lg %lg %lg %lg",index,
	    &(center[0]),&(center[1]),&(center[2]), &radius) != 5){ 
    fprintf(stderr, "Failed to parse shape_sphere for Sphere\n"); 
    exit(EXIT_FAILURE);
  }
}
char* Sphere::name(void){return "sphere";}
void  Sphere::write(int indent,FILE* fp){
  int i;
  for(i=0;i<indent;i++){fprintf(fp," ");}
  fprintf(fp,"#shape_sphere %d\n",material->index);
  for(i=0;i<indent;i++){fprintf(fp," ");}
  fprintf(fp,"  %lg %lg %lg\n",center[0],center[1],center[2]);
  for(i=0;i<indent;i++){fprintf(fp," ");}
  fprintf(fp,"  %lg\n",radius);
}
Flt Sphere::intersect(Ray ray,IntersectionInfo& iInfo){
  if(implementedFlag){
    printf("The Sphere::intersect(Ray ray,IntersectionInfo& iInfo) method has not been implemented\n");
  }
  return -1.0;
}
BoundingBox Sphere::getBoundingBox(void){
  if(implementedFlag){
    printf("The Sphere::getBoundingBox(void) method has not been implemented\n");
  }
  return BoundingBox();
}
